//+------------------------------------------------------------------+
//|                                      CanvasPolylineShadow1_1.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.1"
#property description "Demonstrating Canvas Polyline"
//+------------------------------------------------------------------+
//| V1.1                                               |
//+------------------------------------------------------------------+
//---
#include <Canvas\Canvas.mqh>
//+------------------------------------------------------------------+
//| inputs                                                           |
//+------------------------------------------------------------------+
input int      Width=400;
input int      Height=300;
double         Shift=51.3;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart(void)
  {
   double x[],y[];
//--- check
   if(Width<100 || Height<100)
     {
      Print("Too simple.");
      return(-1);
     }
//--- create canvas
   CCanvas canvas;
   if(!canvas.CreateBitmapLabel("SampleCanvas",0,0,Width,Height,COLOR_FORMAT_ARGB_NORMALIZE))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
//--- drawing
   canvas.Erase(ColorToARGB(clrNONE,0));
   canvas.Update();
//--- start randomizer
   srand(GetTickCount());
//--- draw pixels
   ArrayResize(x,Width);
   ArrayResize(y,Width);
   int p=Height/2;   // Offset on an axis of "Y"
//--- draw polyline
   uint clr_no_alfa=ColorToARGB(clrRed,255);
   uint clr_alfa=ColorToARGB(clrRed,200);
   for(int i=0;i<Width;i++)
     {
      static double increment;
      x[i]=increment;
      y[i]=MathSqrt(Shift*x[i]);
      //Print(x[i],"; ",y[i]);
      canvas.PixelSetAA(x[i],p+y[i],clr_no_alfa);
      canvas.PixelSetAA(x[i],p-y[i],clr_no_alfa);
      increment=increment+0.4;
/*
      //--- Draw a line thickness
      canvas.PixelSet(x[i],p+y[i]+1,clr_alfa);
      //canvas.PixelSet(x[i],p+y[i]-1,clr_alfa);
      canvas.PixelSet(x[i],p-y[i]+1,clr_alfa);
      //canvas.PixelSet(x[i],p-y[i]-1,clr_alfa);
      canvas.PixelSet(x[i],p+y[i]+2,clr_alfa);
      //canvas.PixelSet(x[i],p+y[i]-2,clr_alfa);
      canvas.PixelSet(x[i],p-y[i]+2,clr_alfa);
      //canvas.PixelSet(x[i],p-y[i]-2,clr_alfa);
*/
     }
   canvas.Update();
   Sleep(15000);
//--- finish
   ObjectDelete(0,"SampleCanvas");
   canvas.Destroy();
   return(0);
  }
//+------------------------------------------------------------------+
//| Random RGB color                                                 |
//+------------------------------------------------------------------+
uint RandomRGB(void)
  {
   return(XRGB(rand()%255,rand()%255,rand()%255));
  }
//+------------------------------------------------------------------+
